#include <memory.h>
#include <debug.h>
#include <sys/mman.h>
#include <string.h>

static long _brk = KERNEL_BRK0;
static long _mmap = KERNEL_MMAP;

long k_brk(long brk, long, long, long, long, long) {
  if(brk) {
    while(_brk < brk) {
      vmm_set_page(kernel_P4,
          _brk,
          pmm_alloc(),
          PAGE_GLOBAL | PAGE_WRITE | PAGE_PRESENT
      );
      _brk += PAGE_SIZE;
    }
  }
  return _brk;
}

long k_mmap(
      long addr,
      long length,
      long prot,
      long flags,
      long fd,
      long offset
  ) {
  (void)addr;
  (void)prot;
  (void)flags;
  (void)offset;

  if(fd != -1)
    PANIC("Unknown mmap request\n");
  long pos = (flags & MAP_FIXED) ? addr : _mmap;
  long retval = pos;
  uint64_t p;
  while(length >= 0) {
    p = pmm_alloc();
    vmm_set_page(kernel_P4,
        pos, p,
        PAGE_GLOBAL | PAGE_WRITE | PAGE_PRESENT
    );
    if(flags & MAP_ANONYMOUS) {
      memset((void *)pos, 0, PAGE_SIZE);
    }
    pos += PAGE_SIZE;
    length -= PAGE_SIZE;
  }
  if(!(flags & MAP_FIXED))
    _mmap = pos;
  return retval;
}