#!/bin/sh -e

TARGET=x86_64-elf
SYSROOT=/opt/sysroot

cairo_version=cairo-1.16.0

mkdir -p /opt/external && cd /opt/external
[ -f "${cairo_version}.tar.xz" ] || wget "https://www.cairographics.org/releases/${cairo_version}.tar.xz"
[ -d "${cairo_version}" ] || tar -xf ${cairo_version}.tar.xz

mkdir -p build-cairo && cd build-cairo
rm -rf *
../${cairo_version}/configure \
    --target=${TARGET} \
    --prefix=${SYSROOT}/usr \
    --enable-xlib=no \
    --enable-png=no \
    --enable-script=no \
    --enable-ps=no \
    --enable-pdf=no \
    --enable-svg=no \
    --enable-interpreter=no \
    --enable-shared=no \
    --enable-gtk-doc-html=no \
    CFLAGS="-DCAIRO_NO_MUTEX=1 -mcmodel=large -mno-red-zone -O0 -ggdb" \
    PKG_CONFIG_PATH="${SYSROOT}/usr/lib/pkgconfig"

make
make install
