#!/bin/sh -e

TARGET=x86_64-elf
SYSROOT=/opt/sysroot

pixman_version=pixman-0.40.0

mkdir -p /opt/external && cd /opt/external
[ -f "${pixman_version}.tar.gz" ] || wget "https://www.cairographics.org/releases/${pixman_version}.tar.gz"
[ -d "${pixman_version}" ] || tar -xf ${pixman_version}.tar.gz

mkdir -p build-pixman && cd build-pixman
../${pixman_version}/configure \
    --target=${TARGET} \
    --prefix=${SYSROOT}/usr \
    --with-sysroot=${SYSROOT}\
    CFLAGS="-mcmodel=large -mno-red-zone -O0 -ggdb"

make
make install